diff --git a/gdb/testsuite/gdb.ada/var_rec_arr.exp b/gdb/testsuite/gdb.ada/var_rec_arr.exp
new file mode 100644
index 0000000..82ca857
--- /dev/null
+++ b/gdb/testsuite/gdb.ada/var_rec_arr.exp
@@ -0,0 +1,51 @@
+# Copyright 2015 Free Software Foundation, Inc.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+load_lib "ada.exp"
+
+standard_ada_testfile foo_na09_042
+
+if {[gdb_compile_ada "${srcfile}" "${binfile}" executable [list debug]] != "" } {
+  return -1
+}
+
+clean_restart ${testfile}
+
+set bp_location [gdb_get_line_number "STOP" ${testdir}/foo_na09_042.adb]
+runto "foo_na09_042.adb:$bp_location"
+
+gdb_test "print a1" \
+         " = \\(\\(i => 0, s => \"\"\\), \\(i => 1, s => \"A\"\\), \\(i => 2, s => \"AB\"\\)\\)"
+
+gdb_test "print a1(1)" \
+         " = \\(i => 0, s => \"\"\\)"
+
+gdb_test "print a1(2)" \
+         " = \\(i => 1, s => \"A\"\\)"
+
+gdb_test "print a1(3)" \
+         " = \\(i => 2, s => \"AB\"\\)"
+
+gdb_test "print a2" \
+         " = \\(\\(i => 2, s => \"AB\"\\), \\(i => 1, s => \"A\"\\), \\(i => 0, s => \"\"\\)\\)"
+
+gdb_test "print a2(1)" \
+         " = \\(i => 2, s => \"AB\"\\)"
+
+gdb_test "print a2(2)" \
+         " = \\(i => 1, s => \"A\"\\)"
+
+gdb_test "print a2(3)" \
+         " = \\(i => 0, s => \"\"\\)"
diff --git a/gdb/testsuite/gdb.ada/var_rec_arr/foo_na09_042.adb b/gdb/testsuite/gdb.ada/var_rec_arr/foo_na09_042.adb
new file mode 100644
index 0000000..6737b6e
--- /dev/null
+++ b/gdb/testsuite/gdb.ada/var_rec_arr/foo_na09_042.adb
@@ -0,0 +1,23 @@
+--  Copyright 2015 Free Software Foundation, Inc.
+--
+--  This program is free software; you can redistribute it and/or modify
+--  it under the terms of the GNU General Public License as published by
+--  the Free Software Foundation; either version 3 of the License, or
+--  (at your option) any later version.
+--
+--  This program is distributed in the hope that it will be useful,
+--  but WITHOUT ANY WARRANTY; without even the implied warranty of
+--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+--  GNU General Public License for more details.
+--
+--  You should have received a copy of the GNU General Public License
+--  along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+with Pck; use Pck;
+
+procedure Foo_NA09_042 is
+   R1 : Record_Type := Ident (A1 (3));
+begin
+   Do_Nothing (A1'Address);  -- STOP
+   Do_Nothing (R1'Address);
+end Foo_NA09_042;
diff --git a/gdb/testsuite/gdb.ada/var_rec_arr/pck.adb b/gdb/testsuite/gdb.ada/var_rec_arr/pck.adb
new file mode 100644
index 0000000..cb6e114
--- /dev/null
+++ b/gdb/testsuite/gdb.ada/var_rec_arr/pck.adb
@@ -0,0 +1,28 @@
+--  Copyright 2015 Free Software Foundation, Inc.
+--
+--  This program is free software; you can redistribute it and/or modify
+--  it under the terms of the GNU General Public License as published by
+--  the Free Software Foundation; either version 3 of the License, or
+--  (at your option) any later version.
+--
+--  This program is distributed in the hope that it will be useful,
+--  but WITHOUT ANY WARRANTY; without even the implied warranty of
+--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+--  GNU General Public License for more details.
+--
+--  You should have received a copy of the GNU General Public License
+--  along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+package body Pck is
+
+   function Ident (R : Record_Type) return Record_Type is
+   begin
+      return R;
+   end Ident;
+
+   procedure Do_Nothing (A : System.Address) is
+   begin
+      null;
+   end Do_Nothing;
+
+end Pck;
diff --git a/gdb/testsuite/gdb.ada/var_rec_arr/pck.ads b/gdb/testsuite/gdb.ada/var_rec_arr/pck.ads
new file mode 100644
index 0000000..902cc9f
--- /dev/null
+++ b/gdb/testsuite/gdb.ada/var_rec_arr/pck.ads
@@ -0,0 +1,38 @@
+--  Copyright 2015 Free Software Foundation, Inc.
+--
+--  This program is free software; you can redistribute it and/or modify
+--  it under the terms of the GNU General Public License as published by
+--  the Free Software Foundation; either version 3 of the License, or
+--  (at your option) any later version.
+--
+--  This program is distributed in the hope that it will be useful,
+--  but WITHOUT ANY WARRANTY; without even the implied warranty of
+--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+--  GNU General Public License for more details.
+--
+--  You should have received a copy of the GNU General Public License
+--  along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+with System;
+
+package Pck is
+
+   subtype Small_Type is Integer range 0 .. 10;
+   type Record_Type (I : Small_Type := 0) is record
+      S : String (1 .. I);
+   end record;
+   function Ident (R : Record_Type) return Record_Type;
+
+   type Array_Type is array (Integer range <>) of Record_Type;
+
+   procedure Do_Nothing (A : System.Address);
+
+   A1 : Array_Type := (1 => (I => 0, S => <>),
+                       2 => (I => 1, S => "A"),
+                       3 => (I => 2, S => "AB"));
+
+   A2 : Array_Type := (1 => (I => 2, S => "AB"),
+                       2 => (I => 1, S => "A"),
+                       3 => (I => 0, S => <>));
+
+end Pck;